﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SaveToFileSystem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private string fileName;
        public MainWindow()
        {
            InitializeComponent();
            StreamReader reader = new StreamReader("..\\..\\diagram_xml");
            using (reader)
            {
                string serializedString = reader.ReadToEnd();
                this.diagram.Load(serializedString);
            }
        }

        private void saveButton_Click(object sender, RoutedEventArgs e)
        {
            Stream fileStream = null;
            try
            {
                var dialog = new SaveFileDialog();
                if (dialog.ShowDialog() == true)
                {
                    fileStream = dialog.OpenFile();
                    this.fileName = dialog.FileName;
                }

                using (fileStream)
                {
                    var serializationString = this.diagram.Save();
                    var writer = new StreamWriter(fileStream);
                    writer.Write(serializationString);
                    writer.Flush();
                }
            }
            finally
            {
                if (fileStream != null)
                    fileStream.Close();
            }
        }

        private void loadButton_Click(object sender, RoutedEventArgs e)
        {
            Stream fileStream = null;
            try
            {
                var dialog = new OpenFileDialog();
                dialog.ShowDialog();
                using (fileStream = dialog.OpenFile())
                {
                    StreamReader reader = new StreamReader(fileStream);
                    using (reader)
                    {
                        string serializedString = reader.ReadToEnd();
                        this.diagram.Load(serializedString);
                    }
                }
            }
            finally
            {
                if (fileStream != null)
                    fileStream.Close();
            }
        }
    }
}
